#ifndef _BBCMANAGER_H
#define _BBCMANAGER_H

#include <BBCPrerequisites.h>
#include <BBCUtil.h>
#include <BBCSingleton.h>

namespace BBC {

class _BBCExport BBCManager : public CSingleton<BBCManager> {
  public:
    BBCManager();
	
    ~BBCManager();

	static BBCManager& getSingleton(void);
    
	static BBCManager* getSingletonPtr(void);

	Ogre::Mesh* loadMesh(Ogre::String folderName, Ogre::String fileName);

	Ogre::Mesh* loadXMLMesh(Ogre::String name);

	void saveMesh(Ogre::String name);

	void saveXMLMesh(Ogre::String name);

	void saveMaterial(Ogre::String materialName);

	void initialize(void);

	void shutdown(void);

};

}

#endif

