#ifndef _LBBCBILLBOARDVIEWMODE_H
#define _LBBCBILLBOARDVIEWMODE_H


#include "OBAOgreFrameListenerMode.h"

namespace LBBC {

class BillboardViewMode : public OBA::OgreFrameListenerMode 
{
	public:
		BillboardViewMode(Ogre::RenderWindow* win, unsigned int ogreFrameListenerModeHandle, bool useBufferedInputKeys = false, bool useBufferedInputMouse = false):
		  OBA::OgreFrameListenerMode(win, ogreFrameListenerModeHandle, useBufferedInputKeys, useBufferedInputMouse)
		{
			showDebugOverlay(false);
			mReloadedTextures = false;
		}

		virtual ~BillboardViewMode()
		{
		}

		bool frameStarted(const Ogre::FrameEvent& evt, Ogre::InputReader *inputReader)
		{
			mWindow->getViewport(0)->setBackgroundColour(Ogre::ColourValue(0.0, 0.0, 0.0, 1.0));

			//if (!mReloadedTextures)
			//{
			//	for (unsigned int iSubEntity = 0; iSubEntity < mBillboardCloudEntity->getNumSubEntities(); iSubEntity++)
			//	{
			//		Ogre::MaterialPtr materialPtr = Ogre::MaterialManager::getSingleton().getByName(mBillboardCloudEntity->getSubEntity(iSubEntity)->getMaterialName());
			//		Ogre::LogManager::getSingleton().logMessage("Reloading texture:" + materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->getTextureName());

			//		Ogre::TexturePtr texturePtr = Ogre::TextureManager::getSingleton().getByName(materialPtr->getTechnique(0)->getPass(0)->getTextureUnitState(0)->getTextureName());
			//		texturePtr->reload();
			//		materialPtr->reload();
			//	}
			//	mReloadedTextures = true;
			//}

			return OgreFrameListenerMode::frameStarted(evt, inputReader);	
		}

		void setBillboardCloudMeshName(Ogre::String billboardCloudMeshName)
		{
			mBillboardCloudMeshName = billboardCloudMeshName;
		}

		virtual void createScene()
		{
			mWindow->getViewport(0)->setBackgroundColour(Ogre::ColourValue(0.0, 0.0, 0.0, 1.0));

			Ogre::SceneNode* sNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
			//mBillboardCloudEntity = mSceneMgr->createEntity(mBillboardCloudMeshName, mBillboardCloudMeshName);		
			mBillboardCloudEntity = mSceneMgr->createEntity("chestnutLeavesBillboardCloudGrouped.mesh", "chestnutLeavesBillboardCloudGrouped.mesh");		
			sNode->attachObject(mBillboardCloudEntity);
			sNode->rotate(Ogre::Vector3::UNIT_X, Ogre::Radian(Ogre::Degree(-90.0)));
		}

	protected:
		Ogre::String mBillboardCloudMeshName;

		Ogre::Entity *mBillboardCloudEntity;

		bool mReloadedTextures;
};

}
#endif
