#ifndef _LBBCCLUSTERSVIEWMODE_H
#define _LBBCCLUSTERSVIEWMODE_H

#include <LBBCPrerequisites.h>
#include <OBAOgreFrameListenerMode.h>

namespace LBBC {

class ClusterViewMode : public OBA::OgreFrameListenerMode 
{
	public:
		ClusterViewMode(Ogre::RenderWindow* win, unsigned int ogreFrameListenerModeHandle, bool useBufferedInputKeys = false, bool useBufferedInputMouse = false):
		  OBA::OgreFrameListenerMode(win, ogreFrameListenerModeHandle, useBufferedInputKeys, useBufferedInputMouse)
		{
			showDebugOverlay(false);
		}

		virtual ~ClusterViewMode()
		{
		}

		bool frameStarted(const Ogre::FrameEvent& evt, Ogre::InputReader *inputReader)
		{
			mWindow->getViewport(0)->setBackgroundColour(Ogre::ColourValue(0.0, 0.0, 0.0, 1.0));

			return OgreFrameListenerMode::frameStarted(evt, inputReader);	
		}

		void setEntityClustersMeshName(Ogre::String entityClustersMeshName)
		{
			mEntityClustersMeshName = entityClustersMeshName;
		}

		virtual void createScene()
		{
			mWindow->getViewport(0)->setBackgroundColour(Ogre::ColourValue(0.0, 0.0, 0.0, 1.0));

			Ogre::SceneNode* sNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
			//Ogre::Entity* eLeafClustersGrouped = mSceneMgr->createEntity(mEntityClustersMeshName, mEntityClustersMeshName);					
			Ogre::Entity* eLeafClustersGrouped = mSceneMgr->createEntity("chestnutLeafClustersGrouped.mesh", "chestnutLeafClustersGrouped.mesh");								
			sNode->attachObject(eLeafClustersGrouped);			
			sNode->rotate(Ogre::Vector3::UNIT_X, Ogre::Radian(Ogre::Degree(-90.0)));
		}
	protected:
		Ogre::String mEntityClustersMeshName;


};

}
#endif
